
module BesselK

  using LinearAlgebra, Bessels, ForwardDiff

  export adbesselk, adbesselkxv, matern

  # Here's an ugly work-around since ForwardDiff#481 got merged:
  _iszero(x) = iszero(x)
  _iszero(x::ForwardDiff.Dual) = _iszero(ForwardDiff.value(x))

  # This is probably bad to include here, but the method error seems to happen a
  # lot without it:
  #Base.floatmax(x::Dual{T,V,N}) where{T,V,N} = floatmax(V)

  include("gamma.jl")      # gamma function, for the moment ripped from Bessels.jl
  include("besk_ser.jl")   # enhanced direct series. The workhorse for small-ish args.
  include("besk_as.jl")    # asymptotic expansion for large arg.
  include("uk_polys.jl")   # Uk polynomials, now generated statically ahead of time.
  include("besk_asv.jl")   # uniform expansion for large order.
  include("besk_temme.jl") # Temme recurrence series for small-ish args. For AD.
  include("besk.jl")       # putting it all together with appropriate branching.
  include("matern.jl")     # a basic Matern covariance function

end 

